package com.example.user.myapp;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.os.Handler;
import android.support.v4.content.LocalBroadcastManager;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.widget.TextView;

import java.util.Calendar;
import java.util.Date;

public class DisplayMessageActivity extends AppCompatActivity {

    private Handler handlerCoil;
    private GlobalState state;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_display_message);

        LocalBroadcastManager.getInstance(this).registerReceiver(mMessageReceiver, new IntentFilter("readCoil8192"));
        state = (GlobalState) getApplicationContext();

        handlerCoil = new Handler();
        handlerCoil.post(refreshCoil);
    }

    Runnable refreshCoil = new Runnable() {
        @Override
        public void run() {
        Intent serviceIntent = new Intent(getApplicationContext(), MyIntentService.class);
        serviceIntent.setAction("read.coil");
        serviceIntent.putExtra("extra.ip.address", state.getIpAddress());
        serviceIntent.putExtra("extra.ip.port", state.getPort());
        serviceIntent.putExtra("extra.ref", state.getCoilRef());
        serviceIntent.putExtra("extra.count", state.getCoilCount());
        serviceIntent.putExtra("extra.intent.name", "readCoil8192");
        getApplicationContext().startService(serviceIntent);

        handlerCoil.postDelayed(this, 2000);
        }
    };

    Runnable refreshDiscretInput = new Runnable() {
        @Override
        public void run() {
            // TODO Auto-generated method stub
            TextView textView = findViewById(R.id.textView1);
            Date currentTime = Calendar.getInstance().getTime();
            textView.setText(new Double(Math.random()).toString());
            handlerCoil.postDelayed(this, 1000);
        }
    };

    Runnable refreshInputRegister = new Runnable() {
        @Override
        public void run() {
            // TODO Auto-generated method stub
            TextView textView = findViewById(R.id.textView1);
            Date currentTime = Calendar.getInstance().getTime();
            textView.setText(new Double(Math.random()).toString());
            handlerCoil.postDelayed(this, 1000);
        }
    };

    Runnable refreshHoldingRegister = new Runnable() {
        @Override
        public void run() {
            // TODO Auto-generated method stub
            TextView textView = findViewById(R.id.textView1);
            Date currentTime = Calendar.getInstance().getTime();
            textView.setText(new Double(Math.random()).toString());
            handlerCoil.postDelayed(this, 1000);
        }
    };

    private BroadcastReceiver mMessageReceiver = new BroadcastReceiver() {
        @Override
        public void onReceive(Context context, Intent intent) {
            String action = intent.getAction();
            Bundle bundle = intent.getExtras();
            boolean[] booleanArray = bundle.getBooleanArray("values");

            TextView textView1 = findViewById(R.id.textView1);
            textView1.setText(new Boolean(booleanArray[0]).toString());

            TextView textView2 = findViewById(R.id.textView2);
            textView2.setText(new Boolean(booleanArray[1]).toString());

            TextView textView3 = findViewById(R.id.textView3);
            textView3.setText(new Boolean(booleanArray[2]).toString());

            TextView textView4 = findViewById(R.id.textView4);
            textView4.setText(new Boolean(booleanArray[3]).toString());

            TextView textView5 = findViewById(R.id.textView5);
            textView5.setText(new Boolean(booleanArray[4]).toString());

            TextView textView6 = findViewById(R.id.textView6);
            textView6.setText(new Boolean(booleanArray[5]).toString());

            TextView textView7 = findViewById(R.id.textView7);
            textView7.setText(new Boolean(booleanArray[6]).toString());

            TextView textView8 = findViewById(R.id.textView8);
            textView8.setText(new Boolean(booleanArray[7]).toString());
        }
    };
}
